diff --git a/src/gui/SettingsWidget.cpp b/src/gui/SettingsWidget.cpp
index f57379d7..ab94a15e 100644
--- a/src/gui/SettingsWidget.cpp
+++ b/src/gui/SettingsWidget.cpp
@@ -34,7 +34,7 @@
 #endif
 
 #include <QStackedWidget>
-#include <QStandardPaths>
+#include <QDesktopServices>
 #include <QStyleFactory>
 #include <QImageWriter>
 #include <QRadioButton>
@@ -70,7 +70,7 @@
 #include <MenuBar.hpp>
 #include <Module.hpp>
 
-#if !defined(Q_OS_WIN) && !defined(Q_OS_MACOS) && !defined(Q_OS_ANDROID)
+#if !defined(Q_OS_WIN) && !defined(Q_OS_MAC) && !defined(Q_OS_ANDROID)
     #define ICONS_FROM_THEME
 #endif
 
@@ -129,7 +129,12 @@ void SettingsWidget::InitSettings()
         while (outputFilePath.endsWith("/"))
             outputFilePath.chop(1);
         if (outputFilePath.isEmpty())
-            outputFilePath = QStandardPaths::standardLocations(QStandardPaths::DownloadLocation).value(0, QDir::homePath());
+        {
+            // Qt4 doesn't have DownloadLocation, use DocumentsLocation
+            outputFilePath = QDesktopServices::storageLocation(QDesktopServices::DocumentsLocation);
+            if (outputFilePath.isEmpty())
+                outputFilePath = QDir::homePath();
+        }
         return outputFilePath;
     };
 
@@ -142,7 +147,10 @@ void SettingsWidget::InitSettings()
 
     QMPSettings.init("AudioLanguage", QString());
     QMPSettings.init("SubtitlesLanguage", QString());
-    QMPSettings.init("screenshotPth", []{return QStandardPaths::standardLocations(QStandardPaths::PicturesLocation).value(0, QDir::homePath());});
+    QMPSettings.init("screenshotPth", [] {
+        QString path = QDesktopServices::storageLocation(QDesktopServices::PicturesLocation);
+        return path.isEmpty() ? QDir::homePath() : path;
+    });
     QMPSettings.init("OutputFilePath", getInitialOutpuitFilePath);
 #ifdef Q_OS_WIN
     QMPSettings.init("screenshotFormat", ".bmp");
@@ -221,8 +229,14 @@ void SettingsWidget::InitSettings()
     QMPSettings.init("Vulkan/HQScaleDown", false);
     QMPSettings.init("Vulkan/HQScaleUp", false);
     QMPSettings.init("Vulkan/BypassCompositor", true);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     QMPSettings.init("Vulkan/HDR", QGuiApplication::platformName().contains(QStringLiteral("wayland")));
     QMPSettings.init("Vulkan/BT2020", QGuiApplication::platformName().contains(QStringLiteral("wayland")));
+#else
+    // Qt4: No Wayland support
+    QMPSettings.init("Vulkan/HDR", false);
+    QMPSettings.init("Vulkan/BT2020", false);
+#endif
 
     QMPSettings.init("ShortSeek", 5);
     QMPSettings.init("LongSeek", 30);
@@ -404,7 +418,7 @@ SettingsWidget::SettingsWidget(int page, const QString &moduleName, QWidget *vid
 
         m_outputFileE->setText(QMPSettings.getString("OutputFilePath"));
         m_outputFileB->setIcon(QMPlay2Core.getIconFromTheme("folder-open"));
-        connect(m_outputFileB, &QAbstractButton::clicked, this, &SettingsWidget::chooseOutputFileDir);
+        connect(m_outputFileB, SIGNAL(clicked()), this, SLOT(chooseOutputFileDir()));
 
         connect(m_setAppearanceB, SIGNAL(clicked()), this, SLOT(setAppearance()));
         connect(m_setKeyBindingsB, SIGNAL(clicked()), this, SLOT(setKeyBindings()));
@@ -493,37 +507,29 @@ SettingsWidget::SettingsWidget(int page, const QString &moduleName, QWidget *vid
 
         m_dontUpdateYtDlCB->setChecked(QMPSettings.getBool("YtDl/DontAutoUpdate"));
 
-        connect(m_cookiesFromBrowserCB, &QCheckBox::toggled, this, [this](bool checked) {
-            m_cookiesFromBrowserE->setEnabled(checked);
-        });
-        connect(m_customYtDlCB, &QCheckBox::toggled, this, [this](bool checked) {
-            m_customYtDlE->setEnabled(checked);
-            m_customYtDlB->setEnabled(checked);
-            m_removeYtDlB->setEnabled(!checked);
-        });
-        connect(m_customYtDlB, &QToolButton::clicked, this, [this] {
-            auto path = QFileDialog::getOpenFileName(this, tr("Choose youtube-dl script or executable"), m_customYtDlE->text());
-            if (!path.isEmpty())
-                m_customYtDlE->setText(path);
-        });
-        connect(m_dfltYtDlQualCB, &QCheckBox::toggled, this, [this](bool checked) {
-            m_dfltYtDlQualE->setEnabled(checked);
-        });
-        connect(m_additionalYtDlParamsCB, &QCheckBox::toggled, this, [this](bool checked) {
-            m_additionalYtDlParamsE->setEnabled(checked);
-        });
+        connect(m_cookiesFromBrowserCB, SIGNAL(toggled(bool)), this, SLOT(handleCookiesFromBrowserToggled(bool)));
+        connect(m_customYtDlCB, SIGNAL(toggled(bool)), this, SLOT(handleCustomYtDlToggled(bool)));
+        connect(m_customYtDlB, SIGNAL(clicked()), this, SLOT(handleCustomYtDlBrowseClicked()));
+        connect(m_dfltYtDlQualCB, SIGNAL(toggled(bool)), this, SLOT(handleDfltYtDlQualToggled(bool)));
+        connect(m_additionalYtDlParamsCB, SIGNAL(toggled(bool)), this, SLOT(handleAdditionalYtDlParamsToggled(bool)));
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         emit m_cookiesFromBrowserCB->toggled(m_cookiesFromBrowserCB->isChecked());
         emit m_customYtDlCB->toggled(m_customYtDlCB->isChecked());
         emit m_dfltYtDlQualCB->toggled(m_dfltYtDlQualCB->isChecked());
         emit m_additionalYtDlParamsCB->toggled(m_additionalYtDlParamsCB->isChecked());
+#else
+        // Qt4: signals are protected, trigger slots directly
+        handleCookiesFromBrowserToggled(m_cookiesFromBrowserCB->isChecked());
+        handleCustomYtDlToggled(m_customYtDlCB->isChecked());
+        handleDfltYtDlQualToggled(m_dfltYtDlQualCB->isChecked());
+        handleAdditionalYtDlParamsToggled(m_additionalYtDlParamsCB->isChecked());
+#endif
 
-        connect(m_customYtDlCB, &QCheckBox::toggled, this, [this](bool checked) {
-            m_dontUpdateYtDlCB->setChecked(checked);
-        });
+        connect(m_customYtDlCB, SIGNAL(toggled(bool)), this, SLOT(handleCustomYtDlToggledForAutoUpdate(bool)));
 
         m_removeYtDlB->setIcon(QMPlay2Core.getIconFromTheme("list-remove"));
-        connect(m_removeYtDlB, &QPushButton::clicked, this, &SettingsWidget::removeYouTubeDl);
+        connect(m_removeYtDlB, SIGNAL(clicked()), this, SLOT(removeYouTubeDl()));
 #else
         m_ytDlGB->deleteLater();
         m_ytDlGB = nullptr;
@@ -616,29 +622,13 @@ SettingsWidget::SettingsWidget(int page, const QString &moduleName, QWidget *vid
         m_wheelVolumeB->setChecked(QMPSettings.getBool("WheelVolume"));
 
         m_storeARatioAndZoomB->setChecked(QMPSettings.getBool("StoreARatioAndZoom"));
-        connect(m_storeARatioAndZoomB, &QCheckBox::toggled, this, [this](bool checked) {
-            if (checked)
-            {
-                m_keepZoom->setChecked(true);
-                m_keepARatio->setChecked(true);
-            }
-        });
+        connect(m_storeARatioAndZoomB, SIGNAL(toggled(bool)), this, SLOT(handleStoreARatioAndZoomToggled(bool)));
 
         m_keepZoom->setChecked(QMPSettings.getBool("KeepZoom"));
-        connect(m_keepZoom, &QCheckBox::toggled, this, [this](bool checked) {
-            if (!checked && !m_keepARatio->isChecked())
-            {
-                m_storeARatioAndZoomB->setChecked(false);
-            }
-        });
+        connect(m_keepZoom, SIGNAL(toggled(bool)), this, SLOT(handleKeepZoomToggled(bool)));
 
         m_keepARatio->setChecked(QMPSettings.getBool("KeepARatio"));
-        connect(m_keepARatio, &QCheckBox::toggled, this, [this](bool checked) {
-            if (!checked && !m_keepZoom->isChecked())
-            {
-                m_storeARatioAndZoomB->setChecked(false);
-            }
-        });
+        connect(m_keepARatio, SIGNAL(toggled(bool)), this, SLOT(handleKeepARatioToggled(bool)));
 
         m_showBufferedTimeOnSlider->setChecked(QMPSettings.getBool("ShowBufferedTimeOnSlider"));
         m_savePos->setChecked(QMPSettings.getBool("SavePos"));
@@ -815,7 +805,12 @@ void SettingsWidget::applyProxy()
     Settings &QMPSettings = QMPlay2Core.getSettings();
     if (!QMPSettings.getBool("Proxy/Use"))
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 1, 0)
         qunsetenv("http_proxy");
+#else
+        // Qt4: qunsetenv doesn't exist, use unsetenv from stdlib
+        unsetenv("http_proxy");
+#endif
     }
     else
     {
@@ -1136,9 +1131,9 @@ void SettingsWidget::setupModulesListUi(QGroupBox *ModulesList, UiModulesList &m
     ml.horizontalLayout->addLayout(ml.buttonsW);
 
     ml.moveUp->setToolTip(tr("Move up"));
-    ml.moveUp->setText(QStringLiteral("..."));
+    ml.moveUp->setText(QString("..."));
     ml.moveDown->setToolTip(tr("Move down"));
-    ml.moveDown->setText(QStringLiteral("..."));
+    ml.moveDown->setText(QString("..."));
 }
 
 void SettingsWidget::setupPlaybackUi(QWidget *PlaybackSettings)
@@ -1350,7 +1345,7 @@ void SettingsWidget::setupPlaybackUi(QWidget *PlaybackSettings)
     m_modulesListLayout = new QHBoxLayout();
     playbackLayout->addLayout(m_modulesListLayout);
 
-    QObject::connect(m_restoreAVSStateB, &QCheckBox::toggled, m_disableSubtitlesAtStartup, &QCheckBox::setDisabled);
+    QObject::connect(m_restoreAVSStateB, SIGNAL(toggled(bool)), m_disableSubtitlesAtStartup, SLOT(setDisabled(bool)));
 
     m_replayGain->setTitle(tr("Use available replay gain"));
     m_replayGainAlbum->setText(tr("Album mode for replay gain"));
@@ -1409,9 +1404,16 @@ void SettingsWidget::setupPlaybackUi(QWidget *PlaybackSettings)
 void SettingsWidget::createRendererSettings()
 {
     const auto currentRendererName = QMPlay2Core.rendererName();
+#ifdef USE_VULKAN
+    m_settings = &QMPlay2Core.getSettings();
+    auto settings = m_settings;
+#else
+    // Qt4/No Vulkan: Use local variable
     auto settings = &QMPlay2Core.getSettings();
+#endif
 
-    auto renderers = new QComboBox;
+    m_renderers = new QComboBox;
+    auto renderers = m_renderers;
     renderers->setSizePolicy(QSizePolicy(QSizePolicy::Expanding, QSizePolicy::Preferred));
     renderers->addItem(tr("Legacy"), "legacy");
 #ifdef USE_OPENGL
@@ -1432,13 +1434,23 @@ void SettingsWidget::createRendererSettings()
         renderers->setItemText(i, renderers->itemText(i) + " (" + (active ? tr("active") : tr("inactive")) + ")");
     }
 
-    auto rendererStacked = new QStackedWidget;
+    m_rendererStacked = new QStackedWidget;
+    auto rendererStacked = m_rendererStacked;
 
+#ifdef USE_VULKAN
+    m_canRestart = std::make_shared<bool>(false);
+    auto canRestart = m_canRestart;
+#else
     auto canRestart = std::make_shared<bool>(false);
+#endif
 
     m_rendererApplyFunctions.push_back([=](bool &initFilters) {
         Q_UNUSED(initFilters)
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
         const auto rendererName = renderers->currentData().toString();
+#else
+        const auto rendererName = renderers->itemData(renderers->currentIndex()).toString();
+#endif
         settings->set("Renderer", rendererName);
         if (currentRendererName != rendererName && (*canRestart || chosenRenderer != rendererName))
         {
@@ -1453,10 +1465,10 @@ void SettingsWidget::createRendererSettings()
     };
     auto createBypassCompositor = [] {
         auto bypassCompositor = new QCheckBox(tr("Bypass compositor in full screen"));
-        if (QGuiApplication::platformName() == "xcb")
-        {
-            bypassCompositor->setToolTip(tr("This can improve performance if X11 compositor supports it"));
-        }
+        // Qt4: Use Q_WS_X11 macro
+#ifdef Q_WS_X11
+        bypassCompositor->setToolTip(tr("This can improve performance if X11 compositor supports it"));
+#endif
         return bypassCompositor;
     };
 #endif
@@ -1478,15 +1490,18 @@ void SettingsWidget::createRendererSettings()
     {
         auto openglSettings = new QWidget;
 
-        auto glOnWindow = new QCheckBox(tr("Use OpenGL on entire window"));
-        auto vsync = createVSync();
-        auto bypassCompositor = createBypassCompositor();
+        m_glOnWindow = new QCheckBox(tr("Use OpenGL on entire window"));
+        m_vsyncOpenGL = createVSync();
+        m_bypassCompositorOpenGL = createBypassCompositor();
+        auto glOnWindow = m_glOnWindow;
+        auto vsync = m_vsyncOpenGL;
+        auto bypassCompositor = m_bypassCompositorOpenGL;
 
 #ifdef Q_OS_WIN
         bypassCompositor->setToolTip(tr("This can improve performance. Some video drivers can crash when enabled."));
-#else
-        if (QGuiApplication::platformName() != "xcb")
-            bypassCompositor->setEnabled(false);
+#elif !defined(Q_WS_X11)
+        // Qt4: Not X11, disable bypass compositor
+        bypassCompositor->setEnabled(false);
 #endif
 
         glOnWindow->setToolTip(tr(
@@ -1494,13 +1509,7 @@ void SettingsWidget::createRendererSettings()
             "Use with caution, it can reduce performance of video playback."
         ));
 
-        connect(glOnWindow, &QCheckBox::toggled,
-                this, [=](bool checked) {
-            vsync->setEnabled(!checked);
-#ifdef Q_OS_WIN
-            bypassCompositor->setEnabled(!checked);
-#endif
-        });
+        connect(glOnWindow, SIGNAL(toggled(bool)), this, SLOT(handleGlOnWindowToggled(bool)));
 
         glOnWindow->setChecked(settings->getBool("OpenGL/OnWindow"));
         vsync->setChecked(settings->getBool("OpenGL/VSync"));
@@ -1544,95 +1553,43 @@ void SettingsWidget::createRendererSettings()
     {
         auto vulkanSetttings = new QWidget;
 
-        auto devices = new QComboBox;
-        auto vsync = createVSync();
-        auto gpuDeint = new QCheckBox(tr("Use GPU deinterlacing for CPU-decoded video"));
-        auto forceYadif = new QCheckBox(tr("Force Vulkan Yadif deinterlacing for all hardware decoders"));
-        auto nearestScaling = new QCheckBox(tr("Low quality image scaling (nearest neighbor)"));
-        auto hqDownscale = new QCheckBox(tr("High quality image scaling down"));
-        auto hqUpscale = new QCheckBox(tr("High quality image scaling up"));
-        auto bypassCompositor = createBypassCompositor();
-        auto hdr = new QCheckBox(tr("Try to display HDR10 videos in HDR mode (experimental)"));
-        auto bt2020 = new QCheckBox(tr("Try to display BT.2020 videos in BT.2020 color space (experimental)"));
-
-        auto selectedDeviceFiltersEnabled = std::make_shared<int>(-1);
-
-        connect(nearestScaling, &QCheckBox::toggled,
-                this, [=](bool checked) {
-            hqDownscale->setEnabled(!checked);
-            hqUpscale->setEnabled(!checked);
-        });
-
-#ifdef Q_OS_WIN
-        auto noExclusiveFullScreenDevIDs = std::make_shared<QSet<QByteArray>>();
-#endif
-        auto noFiltersDevIDs = std::make_shared<QSet<QByteArray>>();
-
-        connect(devices, qOverload<int>(&QComboBox::currentIndexChanged),
-                this, [=](int idx) {
-            if (devices->count() <= 1)
-                return;
-            if (idx == 0)
-                idx = 1;
-
-            const bool filtersEnabled = !noFiltersDevIDs->contains(devices->itemData(idx).toByteArray());
-            gpuDeint->setEnabled(filtersEnabled);
-            forceYadif->setEnabled(filtersEnabled);
-
-            if (*selectedDeviceFiltersEnabled == -1)
-                *selectedDeviceFiltersEnabled = filtersEnabled;
+        m_vulkanDevices = new QComboBox;
+        m_vulkanVsync = createVSync();
+        m_gpuDeint = new QCheckBox(tr("Use GPU deinterlacing for CPU-decoded video"));
+        m_forceYadif = new QCheckBox(tr("Force Vulkan Yadif deinterlacing for all hardware decoders"));
+        m_nearestScaling = new QCheckBox(tr("Low quality image scaling (nearest neighbor)"));
+        m_hqDownscale = new QCheckBox(tr("High quality image scaling down"));
+        m_hqUpscale = new QCheckBox(tr("High quality image scaling up"));
+        m_bypassCompositorVulkan = createBypassCompositor();
+        m_hdr = new QCheckBox(tr("Try to display HDR10 videos in HDR mode (experimental)"));
+        m_bt2020 = new QCheckBox(tr("Try to display BT.2020 videos in BT.2020 color space (experimental)"));
+
+        auto devices = m_vulkanDevices;
+        auto vsync = m_vulkanVsync;
+        auto gpuDeint = m_gpuDeint;
+        auto forceYadif = m_forceYadif;
+        auto nearestScaling = m_nearestScaling;
+        auto hqDownscale = m_hqDownscale;
+        auto hqUpscale = m_hqUpscale;
+        auto bypassCompositor = m_bypassCompositorVulkan;
+        auto hdr = m_hdr;
+        auto bt2020 = m_bt2020;
+
+        m_selectedDeviceFiltersEnabled = std::make_shared<int>(-1);
+        auto selectedDeviceFiltersEnabled = m_selectedDeviceFiltersEnabled;
+
+        connect(nearestScaling, SIGNAL(toggled(bool)), this, SLOT(handleNearestScalingToggled(bool)));
 
 #ifdef Q_OS_WIN
-            bypassCompositor->setEnabled(!noExclusiveFullScreenDevIDs->contains(devices->itemData(idx).toByteArray()));
-            hdr->setVisible(QOperatingSystemVersion::current() >= QOperatingSystemVersion::Windows10);
-            bt2020->setVisible(QOperatingSystemVersion::current() >= QOperatingSystemVersion::Windows10);
-#else
-            hdr->setVisible(QGuiApplication::platformName().contains("wayland"));
-            bt2020->setVisible(QGuiApplication::platformName().contains("wayland"));
+        m_noExclusiveFullScreenDevIDs = std::make_shared<QSet<QByteArray>>();
+        auto noExclusiveFullScreenDevIDs = m_noExclusiveFullScreenDevIDs;
 #endif
-        });
+        m_noFiltersDevIDs = std::make_shared<QSet<QByteArray>>();
+        auto noFiltersDevIDs = m_noFiltersDevIDs;
 
-        connect(rendererStacked, &QStackedWidget::currentChanged,
-                this, [=](int idx) {
-            if (devices->count() > 0 || idx != renderers->findData("vulkan"))
-                return;
+        connect(devices, SIGNAL(currentIndexChanged(int)), this, SLOT(handleDevicesCurrentIndexChanged(int)));
 
-            const auto storedID = settings->getByteArray("Vulkan/Device");
-            int idIdx = 0;
-
-            devices->blockSignals(true);
-            for (auto &&physicalDevice : QmVk::Instance::enumerateSupportedPhysicalDevices())
-            {
-                const auto &properties = physicalDevice->properties();
-                const auto id = QmVk::Instance::getPhysicalDeviceID(properties);
-#ifdef Q_OS_WIN
-                if (bypassCompositor->isEnabled())
-                {
-                    if (!physicalDevice->checkExtension(VK_EXT_FULL_SCREEN_EXCLUSIVE_EXTENSION_NAME))
-                        noExclusiveFullScreenDevIDs->insert(id);
-                }
-#endif
-                if (!QmVk::Instance::checkFiltersSupported(physicalDevice))
-                    noFiltersDevIDs->insert(id);
-                devices->addItem(static_cast<const char *>(properties.deviceName), id);
-                if (idIdx == 0 && !storedID.isEmpty() && storedID == id)
-                    idIdx = devices->count();
-            }
-            devices->setCurrentIndex(-1);
-            devices->blockSignals(false);
-
-            if (devices->count() > 0)
-            {
-                devices->insertItem(0, tr("First available device"));
-                devices->setCurrentIndex(idIdx);
-                *canRestart = true;
-            }
-            else
-            {
-                devices->addItem(tr("No supported devices found"));
-                vulkanSetttings->setEnabled(false);
-            }
-        });
+        connect(rendererStacked, SIGNAL(currentChanged(int)), this, SLOT(handleRendererStackedCurrentChanged(int)));
 
         vsync->setTristate(true);
         vsync->setToolTip(tr(
@@ -1643,9 +1600,9 @@ void SettingsWidget::createRendererSettings()
 
 #ifdef Q_OS_WIN
         bypassCompositor->setToolTip(tr("Allow for exclusive fullscreen. This can improve performance."));
-#else
-        if (QGuiApplication::platformName() != "xcb")
-            bypassCompositor->setEnabled(false);
+#elif !defined(Q_WS_X11)
+        // Qt4: Not X11, disable bypass compositor
+        bypassCompositor->setEnabled(false);
 #endif
 
         vsync->setCheckState(settings->getWithBounds("Vulkan/VSync", Qt::Unchecked, Qt::Checked));
@@ -1683,7 +1640,11 @@ void SettingsWidget::createRendererSettings()
 
             if (devices->isEnabled() && devices->count() > 0)
             {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
                 const auto vulkanDeviceID = devices->currentData().toByteArray();
+#else
+                const auto vulkanDeviceID = devices->itemData(devices->currentIndex()).toByteArray();
+#endif
                 if (vulkanDeviceID != settings->getByteArray("Vulkan/Device"))
                 {
                     settings->set("Vulkan/Device", vulkanDeviceID.constData());
@@ -1700,7 +1661,11 @@ void SettingsWidget::createRendererSettings()
             settings->set("Vulkan/BypassCompositor", bypassCompositor->isChecked());
             settings->set("Vulkan/HDR", hdr->isChecked());
             settings->set("Vulkan/BT2020", bt2020->isChecked());
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
             if (renderers->currentData().toString() == "vulkan")
+#else
+            if (renderers->itemData(renderers->currentIndex()).toString() == "vulkan")
+#endif
                 settings->set("Vulkan/UserApplied", true);
 
             *selectedDeviceFiltersEnabled = filtersEnabled;
@@ -1710,10 +1675,7 @@ void SettingsWidget::createRendererSettings()
     }
 #endif
 
-    connect(renderers, qOverload<int>(&QComboBox::currentIndexChanged),
-            this, [=](int idx) {
-        rendererStacked->setCurrentIndex(idx);
-    });
+    connect(renderers, SIGNAL(currentIndexChanged(int)), this, SLOT(handleRenderersCurrentIndexChanged(int)));
 
     if (activeRenderer > -1)
     {
@@ -2244,3 +2206,166 @@ void SettingsWidget::removeProfile()
             }
     }
 }
+
+// Qt4: Helper slot implementations
+
+void SettingsWidget::handleCookiesFromBrowserToggled(bool checked)
+{
+    m_cookiesFromBrowserE->setEnabled(checked);
+}
+
+void SettingsWidget::handleCustomYtDlToggled(bool checked)
+{
+    m_customYtDlE->setEnabled(checked);
+    m_customYtDlB->setEnabled(checked);
+    m_removeYtDlB->setEnabled(!checked);
+}
+
+void SettingsWidget::handleCustomYtDlBrowseClicked()
+{
+    auto path = QFileDialog::getOpenFileName(this, tr("Choose youtube-dl script or executable"), m_customYtDlE->text());
+    if (!path.isEmpty())
+        m_customYtDlE->setText(path);
+}
+
+void SettingsWidget::handleDfltYtDlQualToggled(bool checked)
+{
+    m_dfltYtDlQualE->setEnabled(checked);
+}
+
+void SettingsWidget::handleAdditionalYtDlParamsToggled(bool checked)
+{
+    m_additionalYtDlParamsE->setEnabled(checked);
+}
+
+void SettingsWidget::handleCustomYtDlToggledForAutoUpdate(bool checked)
+{
+    m_dontUpdateYtDlCB->setChecked(checked);
+}
+
+void SettingsWidget::handleStoreARatioAndZoomToggled(bool checked)
+{
+    if (checked)
+    {
+        m_keepZoom->setChecked(true);
+        m_keepARatio->setChecked(true);
+    }
+}
+
+void SettingsWidget::handleKeepZoomToggled(bool checked)
+{
+    if (!checked && !m_keepARatio->isChecked())
+    {
+        m_storeARatioAndZoomB->setChecked(false);
+    }
+}
+
+void SettingsWidget::handleKeepARatioToggled(bool checked)
+{
+    if (!checked && !m_keepZoom->isChecked())
+    {
+        m_storeARatioAndZoomB->setChecked(false);
+    }
+}
+
+void SettingsWidget::handleGlOnWindowToggled(bool checked)
+{
+#ifdef USE_OPENGL
+    m_vsyncOpenGL->setEnabled(!checked);
+#ifdef Q_OS_WIN
+    m_bypassCompositorOpenGL->setEnabled(!checked);
+#endif
+#else
+    Q_UNUSED(checked)
+#endif
+}
+
+void SettingsWidget::handleNearestScalingToggled(bool checked)
+{
+#ifdef USE_VULKAN
+    m_hqDownscale->setEnabled(!checked);
+    m_hqUpscale->setEnabled(!checked);
+#else
+    Q_UNUSED(checked)
+#endif
+}
+
+void SettingsWidget::handleDevicesCurrentIndexChanged(int idx)
+{
+#ifdef USE_VULKAN
+    if (m_vulkanDevices->count() <= 1)
+        return;
+    if (idx == 0)
+        idx = 1;
+
+    const bool filtersEnabled = !m_noFiltersDevIDs->contains(m_vulkanDevices->itemData(idx).toByteArray());
+    m_gpuDeint->setEnabled(filtersEnabled);
+    m_forceYadif->setEnabled(filtersEnabled);
+
+    if (*m_selectedDeviceFiltersEnabled == -1)
+        *m_selectedDeviceFiltersEnabled = filtersEnabled;
+
+#ifdef Q_OS_WIN
+    m_bypassCompositorVulkan->setEnabled(!m_noExclusiveFullScreenDevIDs->contains(m_vulkanDevices->itemData(idx).toByteArray()));
+    m_hdr->setVisible(QOperatingSystemVersion::current() >= QOperatingSystemVersion::Windows10);
+    m_bt2020->setVisible(QOperatingSystemVersion::current() >= QOperatingSystemVersion::Windows10);
+#else
+    // Qt4: No Wayland support
+    m_hdr->setVisible(false);
+    m_bt2020->setVisible(false);
+#endif
+#else
+    Q_UNUSED(idx)
+#endif
+}
+
+void SettingsWidget::handleRendererStackedCurrentChanged(int idx)
+{
+#ifdef USE_VULKAN
+    if (m_vulkanDevices->count() > 0 || idx != m_renderers->findData("vulkan").toInt())
+        return;
+
+    const auto storedID = m_settings->getByteArray("Vulkan/Device");
+    int idIdx = 0;
+
+    m_vulkanDevices->blockSignals(true);
+    for (auto &&physicalDevice : QmVk::Instance::enumerateSupportedPhysicalDevices())
+    {
+        const auto &properties = physicalDevice->properties();
+        const auto id = QmVk::Instance::getPhysicalDeviceID(properties);
+#ifdef Q_OS_WIN
+        if (m_bypassCompositorVulkan->isEnabled())
+        {
+            if (!physicalDevice->checkExtension(VK_EXT_FULL_SCREEN_EXCLUSIVE_EXTENSION_NAME))
+                m_noExclusiveFullScreenDevIDs->insert(id);
+        }
+#endif
+        if (!QmVk::Instance::checkFiltersSupported(physicalDevice))
+            m_noFiltersDevIDs->insert(id);
+        m_vulkanDevices->addItem(static_cast<const char *>(properties.deviceName), id);
+        if (idIdx == 0 && !storedID.isEmpty() && storedID == id)
+            idIdx = m_vulkanDevices->count();
+    }
+    m_vulkanDevices->setCurrentIndex(-1);
+    m_vulkanDevices->blockSignals(false);
+
+    if (m_vulkanDevices->count() > 0)
+    {
+        m_vulkanDevices->insertItem(0, tr("First available device"));
+        m_vulkanDevices->setCurrentIndex(idIdx);
+        *m_canRestart = true;
+    }
+    else
+    {
+        m_vulkanDevices->addItem(tr("No supported devices found"));
+        // Note: Cannot access vulkanSetttings here, but it will be disabled by the count check
+    }
+#else
+    Q_UNUSED(idx)
+#endif
+}
+
+void SettingsWidget::handleRenderersCurrentIndexChanged(int idx)
+{
+    m_rendererStacked->setCurrentIndex(idx);
+}
diff --git a/src/gui/SettingsWidget.hpp b/src/gui/SettingsWidget.hpp
index f1f8d2e4..a01e2e9d 100644
--- a/src/gui/SettingsWidget.hpp
+++ b/src/gui/SettingsWidget.hpp
@@ -36,6 +36,9 @@ class QPushButton;
 class QToolButton;
 class QListWidget;
 class QTabWidget;
+class QStackedWidget;
+class QCheckBox;
+class QComboBox;
 class Page3;
 class Page4;
 class Page5;
@@ -50,7 +53,7 @@ struct UiModulesList
     QToolButton *moveDown;
 };
 
-class SettingsWidget final : public QWidget
+class SettingsWidget : public QWidget
 {
     Q_OBJECT
 public:
@@ -79,8 +82,8 @@ private:
 
     inline QString getSelectedProfile();
 
-    void showEvent(QShowEvent *) override;
-    void closeEvent(QCloseEvent *) override;
+    void showEvent(QShowEvent *);
+    void closeEvent(QCloseEvent *);
 
 private:
     UiModulesList modulesList[3];
@@ -200,6 +203,32 @@ private:
 
     std::function<void()> m_setRenderersCurrentIndexFn;
     std::vector<std::function<void(bool &initFilters)>> m_rendererApplyFunctions;
+
+    // Qt4: Helper pointers for renderer settings
+    QCheckBox *m_glOnWindow;
+    QCheckBox *m_vsyncOpenGL;
+    QCheckBox *m_bypassCompositorOpenGL;
+    QCheckBox *m_nearestScaling;
+    QCheckBox *m_hqDownscale;
+    QCheckBox *m_hqUpscale;
+    QComboBox *m_vulkanDevices;
+    QStackedWidget *m_rendererStacked;
+    QComboBox *m_renderers;
+    QCheckBox *m_vulkanVsync;
+    QCheckBox *m_gpuDeint;
+    QCheckBox *m_forceYadif;
+    QCheckBox *m_bypassCompositorVulkan;
+    QCheckBox *m_hdr;
+    QCheckBox *m_bt2020;
+#ifdef USE_VULKAN
+    std::shared_ptr<int> m_selectedDeviceFiltersEnabled;
+#ifdef Q_OS_WIN
+    std::shared_ptr<QSet<QByteArray>> m_noExclusiveFullScreenDevIDs;
+#endif
+    std::shared_ptr<QSet<QByteArray>> m_noFiltersDevIDs;
+    Settings *m_settings;
+    std::shared_ptr<bool> m_canRestart;
+#endif
 private slots:
     void chStyle();
     void apply();
@@ -208,20 +237,36 @@ private slots:
     void openModuleSettings(QListWidgetItem *);
     void moveModule();
     void chooseScreenshotDir();
-private:
+private slots:
     void chooseOutputFileDir();
 private slots:
     void setAppearance();
     void setKeyBindings();
     void clearCoversCache();
 #ifdef USE_YOUTUBEDL
-private:
+private slots:
     void removeYouTubeDl();
 private slots:
 #endif
     void resetSettings();
     void profileListIndexChanged(int index);
     void removeProfile();
+
+    // Qt4: Helper slots for lambda conversions
+    void handleCookiesFromBrowserToggled(bool checked);
+    void handleCustomYtDlToggled(bool checked);
+    void handleCustomYtDlBrowseClicked();
+    void handleDfltYtDlQualToggled(bool checked);
+    void handleAdditionalYtDlParamsToggled(bool checked);
+    void handleCustomYtDlToggledForAutoUpdate(bool checked);
+    void handleStoreARatioAndZoomToggled(bool checked);
+    void handleKeepZoomToggled(bool checked);
+    void handleKeepARatioToggled(bool checked);
+    void handleGlOnWindowToggled(bool checked);
+    void handleNearestScalingToggled(bool checked);
+    void handleDevicesCurrentIndexChanged(int idx);
+    void handleRendererStackedCurrentChanged(int idx);
+    void handleRenderersCurrentIndexChanged(int idx);
 signals:
     void settingsChanged(int, bool, bool initFilters);
     void setWheelStep(int);
diff --git a/src/gui/ShortcutHandler.hpp b/src/gui/ShortcutHandler.hpp
index 097839db..1ec3f39e 100644
--- a/src/gui/ShortcutHandler.hpp
+++ b/src/gui/ShortcutHandler.hpp
@@ -23,7 +23,7 @@
 
 class QAction;
 
-class ShortcutHandler final : public QAbstractTableModel
+class ShortcutHandler : public QAbstractTableModel
 {
     Q_DECLARE_TR_FUNCTIONS(ShortcutHandler)
 
@@ -31,15 +31,15 @@ public:
     ShortcutHandler(QObject *parent);
     ~ShortcutHandler();
 
-    int columnCount(const QModelIndex &parent) const override;
-    int rowCount(const QModelIndex &parent) const override;
+    int columnCount(const QModelIndex &parent) const;
+    int rowCount(const QModelIndex &parent) const;
 
-    Qt::ItemFlags flags(const QModelIndex &index) const override;
+    Qt::ItemFlags flags(const QModelIndex &index) const;
 
-    QVariant headerData(int section, Qt::Orientation orientation, int role) const override;
+    QVariant headerData(int section, Qt::Orientation orientation, int role) const;
 
-    QVariant data(const QModelIndex &index, int role) const override;
-    bool setData(const QModelIndex &index, const QVariant &value, int role) override;
+    QVariant data(const QModelIndex &index, int role) const;
+    bool setData(const QModelIndex &index, const QVariant &value, int role);
 
     void appendAction(QAction *action, const QString &settingsName, const QString &defaultShortcut);
 
